package com.inopiasoft.EventsDroid;

import java.util.HashMap;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.text.Html;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;

public class EventsEntityActivity extends Activity implements OnClickListener{
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.detallentitat);
		
		String id_entitat = getIntent().getExtras().getString("id_entitat");
		Toast.makeText(EventsEntityActivity.this, "ID entitat '" +id_entitat+ " pulsado.", Toast.LENGTH_LONG).show();
		
		// Carreguem l'entitat via crida a l'API 
		HashMap<String, Object> entitatMap = loadEntitat(id_entitat);
		setViewValues(entitatMap);
				
	}
	
	private HashMap<String, Object> loadEntitat(String id_entitat) {
	    String url = getString(R.string.base_url)+"indexApi.php?accion=get_entitat&id_entitat="+id_entitat; 
		
	    //ArrayList<HashMap<String, Object>> mylist = new ArrayList<HashMap<String, Object>>();
		String xml = XMLfunctions.getXML(url);
		System.out.println(xml);
        Document doc = XMLfunctions.XMLfromString(xml);
                
        int numResults = XMLfunctions.numResults(doc);
        System.out.println("RESULTS: "+ numResults);               
		NodeList nodes = doc.getElementsByTagName("entitat");
		HashMap<String, Object> map = new HashMap<String, Object>();
		System.out.println("NODES LENGTH: "+nodes.getLength());
		for (int i = 0; i < nodes.getLength(); i++) {							
			map = new HashMap<String, Object>();	
			Element e = (Element)nodes.item(i);
			map.put("id_entitat", XMLfunctions.getValue(e, "id_entitat"));
        	map.put("nom_entitat", "" + XMLfunctions.getValue(e, "nom_entitat"));
        	NodeList desc = e.getElementsByTagName("descripcio");
            Element line = (Element) desc.item(0);
            System.out.println("Title: " + XMLfunctions.getCharacterDataFromElement(line));
            
        	map.put("descripcio", XMLfunctions.getCharacterDataFromElement(line));
        	map.put("lat", "" + XMLfunctions.getValue(e, "lat"));
        	map.put("lon", "" + XMLfunctions.getValue(e, "lon"));
        	map.put("email", "" + XMLfunctions.getValue(e, "email"));
        	map.put("adresa_www", "" + XMLfunctions.getValue(e, "adresa_www"));
        	map.put("telefon", "" + XMLfunctions.getValue(e, "telefon"));
        	map.put("nom_via", "" + XMLfunctions.getValue(e, "nom_via"));
        	map.put("num_via", "" + XMLfunctions.getValue(e, "num_via"));
        	
		}
		
		return map;
		
	}
	
private void setViewValues(HashMap<String, Object> map) {
		
		TextView title = (TextView)findViewById(R.id.txt_ent_title);
		TextView mail  = (TextView)findViewById(R.id.idEmailEntitat);
		TextView web  = (TextView)findViewById(R.id.idWebEntitat);
		TextView telf  = (TextView)findViewById(R.id.telfEntitat);
		TextView descripcio = (TextView)findViewById(R.id.txtDetallEntitat);
		TextView adresa = (TextView)findViewById(R.id.txtAdresaEntitat);
		
		
		ImageButton btn = (ImageButton) findViewById(R.id.idBtnSendEmail);
		ImageButton btn2 = (ImageButton) findViewById(R.id.idBtnWww);
		
		title.setText(map.get("nom_entitat").toString());
		mail.setText(map.get("email").toString());
		web.setText(map.get("adresa_www").toString());
		telf.setText(map.get("telefon").toString());
		descripcio.setText(Html.fromHtml(map.get("descripcio").toString()));
		System.out.println("desc: "+map.get("descripcio").toString());
		adresa.setText(map.get("nom_via") + ", "+ map.get("num_via"));
		
		
		web.setOnClickListener(this);
		btn.setOnClickListener(this);
		btn2.setOnClickListener(this);
		
		
	
	}
		
@Override
public void onClick(View v) {
	switch(v.getId()){
       case R.id.idBtnSendEmail:
    	   final Intent emailIntent = new Intent(android.content.Intent.ACTION_SEND);
    	   emailIntent .setType("plain/text");
    	   TextView mail  = (TextView)findViewById(R.id.idEmailEntitat);
    	   TextView title = (TextView)findViewById(R.id.txt_ent_title);
           emailIntent .putExtra(android.content.Intent.EXTRA_EMAIL, mail.getText());    	   
     	   emailIntent .putExtra(android.content.Intent.EXTRA_SUBJECT, "Ms informaci per "+title.getText());
    	   emailIntent .putExtra(android.content.Intent.EXTRA_TEXT, "Hola, ");
    	   startActivity(Intent.createChooser(emailIntent, "Envia correu..."));

    	   break;
       case R.id.idBtnWww:
    	   TextView wwweb  = (TextView)findViewById(R.id.idWebEntitat);
    	   String url = wwweb.getText().toString();
    	   Intent i = new Intent(Intent.ACTION_VIEW);
    	   i.setData(Uri.parse(url));
    	   startActivity(i);

    	   break;
       case R.id.txtLloc:
    	   
    	   //Intent k = new Intent(this, EventsEntityActivity.class);
    	   //k.putExtra("id_entitat", id_entitat);
		   //startActivity(k);
    	   break;
    
	}
}	
}
