package com.inopiasoft.EventsDroid;
/**
 * Mostra la llista d'esdeveniments
 */
import java.util.ArrayList;
import java.util.HashMap;

import android.app.ListActivity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;
import android.widget.Toast;

public class EventsListsActivity extends ListActivity  {
	
	private LocationManager locmgr = null;
	private double lat, lon;
	ArrayList<HashMap<String, Object>> mylist;
	EventsApiHelper eventsApiHelper;
	String xml; 
	
	String id_tipus_esdeviment;
	String id_entitat;
	SimpleAdapter  adapter;
	String orderby ="1"; 
	
	/**
	 * Obt dels serveis del sistema la latitud i longitud del dispositiu
	 * ms recent
	 * telnet localhost 5554
	 * geo fix 79.00000 13.000000
	 * 
	 **/
	
	
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // Preparamos la lista personalizada
        setContentView(R.layout.listplaceholder);
        
     // getIntent().getExtras().getString("id_tipus_esdeveniment")
   		TextView tv = (TextView) findViewById(R.id.tipusTitle);
   		tv.setText(getIntent().getExtras().getString("desc_tipus_esdeveniment"));
   		if (getIntent().getExtras().getString("desc_tipus_esdeveniment")== null) {
   			System.out.println("POSEM NOM ENTITAT");
   			tv.setText(getIntent().getExtras().getString("nom_entitat"));
   		}
   		if (tv.getText()==null) tv.setText(getIntent().getExtras().getString("nom_entitat"));
   		id_tipus_esdeviment = getIntent().getExtras().getString("id_tipus_esdeveniment");
   		id_entitat = getIntent().getExtras().getString("id_entitat");
   		if (id_tipus_esdeviment==null) { id_tipus_esdeviment = ""; }
   		if (id_entitat == null) { id_entitat = ""; }
        // Barra de progres, i crrega de dades en segon thread
        final ProgressDialog pd = ProgressDialog.show(this, "", getString(R.string.txtloading), true);
        new Thread(new Runnable() {
        public void run() {
        	crearListViewEvents();
        	pd.dismiss();
        }
        }).start();
        
        //Button b2 = (Button) findViewById(R.id.button2);
        //Button b3 = (Button) findViewById(R.id.button3);
        
        /*b2.setOnClickListener(this);
   		b3.setOnClickListener(this);
        */
        // Recuperem el identificadord el tipus d'esdeveniment
        Toast.makeText(EventsListsActivity.this, "ID ESD: '" + id_tipus_esdeviment + "' ID ENT: "+id_entitat+" pasado.", Toast.LENGTH_LONG).show();
        
        // Obtenemos la ultima lat i lon
        //getLastLocation();
       
    }

    
    public void crearListViewEvents() {
    	eventsApiHelper = new EventsApiHelper(getResources());
    	System.out.println("Llamada a location manager");
		EventsLocationManager elm = new EventsLocationManager(this.getBaseContext());
		elm.getLastLocation();
		lat = elm.getLat();
		lon = elm.getLon();
    	int numResults = eventsApiHelper.getEsdeveniments(id_tipus_esdeviment, id_entitat, orderby, (int)lat,(int)lon);
    	mylist = eventsApiHelper.getMylist();

    	if((numResults <= 0)){
        	Toast.makeText(EventsListsActivity.this, "No hay resultados", Toast.LENGTH_LONG).show();  
        	finish();
        }
       
		adapter = new SimpleAdapter(this, mylist , R.layout.llistaesdeveniments, 
                        new String[] { "nom", "entitat", "datahora", "distance" }, 
                        new int[] { R.id.item_title, R.id.item_subtitle, R.id.item_datahora, R.id.item_distance});
        
        adapter.setViewBinder(new MyViewBinder());
        
        runOnUiThread(new Runnable() {
            public void run() {
           	 setListAdapter(adapter);
            }
        });
        
        final ListView lv = getListView();
        lv.setTextFilterEnabled(true);	
        lv.setOnItemClickListener(new OnItemClickListener() {
        	public void onItemClick(AdapterView<?> parent, View view, int position, long id) {        		
        		@SuppressWarnings("unchecked")
				HashMap<String, String> o = (HashMap<String, String>) lv.getItemAtPosition(position);
        		
        		//Intent i = new Intent(parent.getContext(), EventsDetailActivity.class);
        		Intent i = new Intent(parent.getContext(), EventsTabsActivity.class);
        		i.putExtra("id_esdeveniment", o.get("id_esdeveniment"));
        		i.putExtra("id_entitat", o.get("id_entitat"));
        		i.putExtra("lat", o.get("lat"));
        		i.putExtra("lon", o.get("lon"));
    			startActivity(i);
        		//Toast.makeText(EventsListsActivity.this, "ID '" + o.get("id") + "' pulsado.", Toast.LENGTH_LONG).show(); 

			}
		});
    }
    
   
    
    @Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.menulistesdeveniments, menu);
		return true;
	}

	/**
	 * 
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle item selection
		switch (item.getItemId()) {
		case R.id.orderbyname:
			if (orderby.equals("1")) {
				orderby="4";
				item.setTitle("Per Nom <");
			}
			else  {
				orderby = "1";
				item.setTitle("Per Nom >");
			}
			break;
		case R.id.orderbydate:
			if (orderby.equals("2")) {
				orderby = "5";
				item.setTitle("Per Data <");				
			}
			else {
				orderby= "2";
				item.setTitle("Per Data >");
			}
			
			break;
		case R.id.orderbydist:
			if (orderby.equals("3")) {
				orderby ="6";
				item.setTitle("Per Distncia <");
			}
			else {
				orderby ="3";
				item.setTitle("Per Distncia >");
			}
			
			break;
		default:
			return super.onOptionsItemSelected(item);
		}
		
		
    	System.out.println("MIDA PREVIA1: "+mylist.size());
    	eventsApiHelper = new EventsApiHelper(getResources());
    	
    	int numResults = eventsApiHelper.getEsdeveniments(id_tipus_esdeviment, id_entitat, orderby, (int)lat,(int)lon);
		System.out.println("MIDA PREVIA2: "+mylist.size());
		mylist = eventsApiHelper.getMylist();
		System.out.println("MIDA: "+mylist.size());
		adapter = new SimpleAdapter(this, mylist , R.layout.llistaesdeveniments, 
                new String[] { "nom", "entitat", "datahora", "distance" }, 
                new int[] { R.id.item_title, R.id.item_subtitle, R.id.item_datahora, R.id.item_distance});

		adapter.setViewBinder(new MyViewBinder());
		setListAdapter(adapter);
		return true;
	}

}
            


     

