package com.inopiasoft.EventsDroid;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import android.content.res.Resources;
import android.graphics.drawable.Drawable;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.KeyEvent;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;

public class EventsMapActivity extends MapActivity {
	//0BHJDCWajVa4modCLu02JqCOHroR9ws14zgOUpA
	/*
	 * C:\Archivos de programa\Java\jre6\bin>keytool -list -alias androiddebugkey -keys
tore "C:\Documents and Settings\dhernanj\.android\debug.keystore" -storepass and
roid -keypass android
androiddebugkey, 24-jun-2011, PrivateKeyEntry,
Huella digital de certificado (MD5): D6:3B:2D:3C:B2:7A:62:31:91:74:46:25:CE:C3:F
A:15

Intent intent = new Intent(android.content.Intent.ACTION_VIEW, 
Uri.parse("http://maps.google.com/maps?saddr=20.344,34.34&daddr=20.5666,45.345"));
startActivity(intent);


	 */
	private MapView map;
	private MapController mc;
	private static int zoomValue = 16;
	private ArrayList<OverlayItem> mOverlays = new ArrayList<OverlayItem>();
	LocationManager locmgr;
	// Home
	double myLat;
	double myLon;

	// temp for points
	double lat;
	double lon;
	ArrayList<Punto> points;
	
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
	  super.onCreate(savedInstanceState);
	  setContentView(R.layout.map);
	  map = (MapView) findViewById(R.id.mapview);
	  mc = map.getController();
	  
	  // Obtenim localitzacio del dispositiu
	  EventsLocationManager elm = new EventsLocationManager(this.getBaseContext());
	  elm.getLastLocation();
	  myLat = elm.getLat();
	  myLon = elm.getLon();
	  GeoPoint point = new GeoPoint((int) (myLat),(int) (myLon ));
	  
	  String tipusMapa = getIntent().getExtras().getString("tipusMapa");
	  if (tipusMapa.equals("SINGLE")) {
		  String id_entitat = getIntent().getExtras().getString("id_entitat");
		  lat = Double.parseDouble(getIntent().getExtras().getString("lat"));
		  lat = lat * 1E6;
		  lon = Double.parseDouble(getIntent().getExtras().getString("lon"));
		  lon = lon * 1E6;		  
		  points = loadPoints(getResources(), id_entitat);
	  } else {
		  // Multiple
		  points = loadPoints(getResources(), "");
	  }
	  mc.setCenter(point);
	  MapView mapView = (MapView) findViewById(R.id.mapview);
	  mapView.setBuiltInZoomControls(true);
	  List<Overlay> mapOverlays = mapView.getOverlays();
	  afegeixPunts(mc, mapOverlays, point, points);
	  
	}

	@Override
	public boolean dispatchKeyEvent(KeyEvent event) {
	if(event.getKeyCode() == KeyEvent.KEYCODE_DPAD_UP) {
	zoomValue = zoomValue + 1;
	mc.setZoom(zoomValue);
	} else if(event.getKeyCode() == KeyEvent.KEYCODE_DPAD_DOWN) {
	zoomValue = zoomValue - 1;
	mc.setZoom(zoomValue);
	} else if(event.getKeyCode() == KeyEvent.KEYCODE_DPAD_LEFT) {
	map.setSatellite(false);
	} else if(event.getKeyCode() == KeyEvent.KEYCODE_DPAD_RIGHT) {
	map.setSatellite(true);
	}
	return super.dispatchKeyEvent(event);
	}

	@Override
	protected boolean isRouteDisplayed() {
	return false;
	}
	
	private void afegeixPunts(MapController m, List<Overlay> mapOverlays, GeoPoint home, ArrayList<Punto> points) {
		
		int minLat = Integer.MAX_VALUE;
		int maxLat = Integer.MIN_VALUE;
		int minLon = Integer.MAX_VALUE;
		int maxLon = Integer.MIN_VALUE;

		
		Drawable drawable = this.getResources().getDrawable(R.drawable.map_marker_red);
		EventsMapItemizedOverlay itemizedoverlay = new EventsMapItemizedOverlay(drawable,this);
		
		for (int i =0; i < points.size(); i++) {
			CustomOverlayItem overlayitem = new CustomOverlayItem(points.get(i).getGeopoint(), points.get(i).getTitle(), points.get(i).getText(), points.get(i).getId());
			itemizedoverlay.addOverlay(overlayitem);
			mapOverlays.add(itemizedoverlay);
			
			int lat = points.get(i).getGeopoint().getLatitudeE6();
		    int lon = points.get(i).getGeopoint().getLongitudeE6();
		    System.out.println("LAT: "+lat + " LON: "+lon);
            maxLat = Math.max(lat, maxLat);
		    minLat = Math.min(lat, minLat);
		    maxLon = Math.max(lon, maxLon);
		    minLon = Math.min(lon, minLon);
		}
		
		Drawable drawable2 = this.getResources().getDrawable(R.drawable.map_marker_green);
		EventsMapItemizedOverlay itemizedoverlay2 = new EventsMapItemizedOverlay(drawable2,this);
		CustomOverlayItem overlayitem2 = new CustomOverlayItem(home, "On soc!", "Aquesta s la meva posici!", "-1");
		itemizedoverlay2.addOverlay(overlayitem2);
		mapOverlays.add(itemizedoverlay2);
		
		 maxLat = Math.max(home.getLatitudeE6(), maxLat);
		    minLat = Math.min(home.getLatitudeE6(), minLat);
		    maxLon = Math.max(home.getLongitudeE6(), maxLon);
		    minLon = Math.min(home.getLongitudeE6(), minLon);
		
		    double fitFactor = 1.5;
		    m.zoomToSpan((int) (Math.abs(maxLat - minLat) * fitFactor), (int)(Math.abs(maxLon - minLon) * fitFactor));
		    m.animateTo(new GeoPoint( (maxLat + minLat)/2, 
				    (maxLon + minLon)/2 ));

		
//		Double lat = 41.4118315*1E6;
	//	Double lng = 2.1726512*1E6;	    
//		GeoPoint point = new GeoPoint(lat.intValue(),lng.intValue());
		  
		

		
		  
	}
	
	private ArrayList<Punto> loadPoints(Resources res, String id_entitat) {
		ArrayList<Punto> lista = new ArrayList<Punto>();
		String orderBy = "1";
		
        String xml = XMLfunctions.getXML(res.getString(R.string.base_url)+"indexApi.php?accion=get_entitats&id_entitat="+id_entitat);
        System.out.print(xml);
        Document doc = XMLfunctions.XMLfromString(xml);
                
        int numResults = XMLfunctions.numResults(doc);
                
		NodeList nodes = doc.getElementsByTagName("entitat");
		System.out.println("NODOS: "+nodes.getLength());
		for (int i = 0; i < nodes.getLength(); i++) {							
			Element e = (Element)nodes.item(i);
			try{
				double lat = Double.parseDouble(XMLfunctions.getValue(e, "lat"));
				double lon = Double.parseDouble(XMLfunctions.getValue(e, "lon"));
				 
				lat = lat * 1E6;
				lon = lon * 1E6;
				System.out.println("OMPLINT LATLON: "+lat+" "+lon);
				GeoPoint gp = new GeoPoint((int) lat, (int) lon);
				
				Punto p = new Punto(gp, XMLfunctions.getValue(e, "id_entitat"), XMLfunctions.getValue(e, "conta"));
				p.setTitle(XMLfunctions.getValue(e, "nom_entitat"));
				p.setText(XMLfunctions.getValue(e, "num_esdeveniments")+ " esdeveniments ");
				lista.add(p);
			} catch (Exception ex) {
				
			}
			
        	
		}
		return(lista);
		
	}
	
	
	
	

}
