package com.inopiasoft.EventsDroid;

import java.util.ArrayList;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.net.Uri;

import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.OverlayItem;

public class EventsMapItemizedOverlay extends ItemizedOverlay<OverlayItem> {
	private ArrayList<OverlayItem> mOverlays = new ArrayList<OverlayItem>();
	private Context mContext;
	private String itemid;
	private String title;
	

	public EventsMapItemizedOverlay(Drawable defaultMarker, Context context) {
		super(boundCenterBottom(defaultMarker));
		mContext = context;
	}

	public void addOverlay(OverlayItem overlay) {
		mOverlays.add(overlay);
		populate();
	}

	@Override
	protected OverlayItem createItem(int i) {
		return mOverlays.get(i);
	}

	@Override
	public int size() {
		return mOverlays.size();
	}

	@Override
	protected boolean onTap(int index) {
		CustomOverlayItem item = (CustomOverlayItem) mOverlays.get(index);
		AlertDialog.Builder dialog = new AlertDialog.Builder(mContext);
		dialog.setTitle(item.getTitle());
		title = item.getTitle();
		dialog.setMessage(item.getSnippet());
		itemid = item.getmId();
		dialog.setCancelable(true);
		if (!itemid.equals("-1")) 
		dialog.setPositiveButton("Veure",
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						Intent intent = new Intent(
								mContext,
								com.inopiasoft.EventsDroid.EventsListsActivity.class);
						intent.putExtra("id_entitat", itemid);
						intent.putExtra("nom_entitat", title);
						// intent.putExtra("isConnected",
						// MainMap.getIsConnected());
						mContext.startActivity(intent);
					}
				});
		dialog.setNegativeButton("Tanca",
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						dialog.dismiss();
						

					}
				});
		if (!itemid.equals("-1")) 
		dialog.setNeutralButton("Ruta",
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						Intent intent = new Intent(android.content.Intent.ACTION_VIEW, 
								Uri.parse("geo:0,0?q=cerdea 517"));
						mContext.startActivity(intent);
					}
				});
		//dialog.setNeutralButton(", listener)(text, listener)
		dialog.show();
		return true;
	}

}