package com.inopiasoft.EventsDroid;

import java.util.LinkedList;

import android.app.Activity;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

public class EventsPreferencesActivity extends Activity  implements OnClickListener, OnItemSelectedListener {
    public static final String PREFS_NAME = "EventsDroidPreferences";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
	
		super.onCreate(savedInstanceState);
		setContentView(R.layout.preferencias);
		
		// Inicializamos spinner de radio
		LinkedList<EventsRadiItem> items = new LinkedList<EventsRadiItem>();
		//La poblamos con los ejemplos
		items.add(new EventsRadiItem(1, "500m"));
		items.add(new EventsRadiItem(2, "1km"));
		items.add(new EventsRadiItem(3, "2km"));
		
		//Creamos el adaptador
		ArrayAdapter<EventsRadiItem> spinner_adapter = new ArrayAdapter<EventsRadiItem>(this, android.R.layout.simple_spinner_item, items);
		//Aadimos el layout para el men y se lo damos al spinner
		spinner_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		Spinner s = (Spinner) findViewById(R.id.spinner1);
		
		s.setAdapter(spinner_adapter);
		s.setPrompt(getString(R.string.radicerca));
		s.setOnItemSelectedListener(this);
		
		SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
		String radi = settings.getString("radi", "1");
	    String chkvalue  = settings.getString("stats", "0");
	    CheckBox chk = (CheckBox) findViewById(R.id.checkBox1);
	    chk.setChecked("1".equals(chkvalue));
	    
		Button bSave = (Button) findViewById(R.id.savebutton);
		bSave.setOnClickListener(this);
		
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
   	  	SharedPreferences.Editor editor = settings.edit();
   	  	editor.putString("radi", "2");
   	    
   	    CheckBox chk = (CheckBox) findViewById(R.id.checkBox1);
   	    if (chk.isChecked()) {
   	    	editor.putString("stats", "1");	
   	    } else {
   	    	editor.putString("stats", "0");
   	    }
   	  	editor.commit();
   	  	 
   	  	String radi = settings.getString("radi", "1");
   	    Toast.makeText(EventsPreferencesActivity.this, "Preferencia desada "+radi, Toast.LENGTH_LONG).show();
   	    
	}

	@Override
	public void onItemSelected(AdapterView<?> parent, View view, int pos,
			long id) {
		
		if (parent.getId() == R.id.spinner1) {
			EventsRadiItem radi = (EventsRadiItem) parent.getItemAtPosition(pos);
			Toast.makeText(EventsPreferencesActivity.this, "ID "+radi.getId(), Toast.LENGTH_LONG).show();
			SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
	   	  	SharedPreferences.Editor editor = settings.edit();
	   	  	editor.putString("radi", radi.getId()+"");
	   	  	editor.commit();
		}
		
	}

	@Override
	public void onNothingSelected(AdapterView<?> arg0) {
		// TODO Auto-generated method stub
		
	}
	
	
	
	
	
}
