package com.inopiasoft.EventsDroid;

import android.app.TabActivity;
import android.content.Intent;
import android.content.res.Resources;
import android.os.Bundle;
import android.widget.TabHost;

public class EventsTabsActivity extends TabActivity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.tab);

        Resources res = getResources(); // Resource object to get Drawables
        TabHost tabHost = getTabHost();  // The activity TabHost
        TabHost.TabSpec spec;  // Resusable TabSpec for each tab
        Intent intent;  // Reusable Intent for each tab

        // Create an Intent to launch an Activity for the tab (to be reused)
        intent = new Intent().setClass(this, EventsDetailActivity.class);
        intent.putExtra("id_esdeveniment", getIntent().getExtras().getString("id_esdeveniment"));
        // Initialize a TabSpec for each tab and add it to the TabHost
        spec = tabHost.newTabSpec("eventsdetail").setIndicator("Detall",
                          res.getDrawable(R.drawable.event_icon))
                      .setContent(intent);
        
        tabHost.addTab(spec);
        

        // Do the same for the other tabs
        intent = new Intent().setClass(this, EventsEntityActivity.class);
        intent.putExtra("id_entitat", getIntent().getExtras().getString("id_entitat"));
        spec = tabHost.newTabSpec("entitydetail").setIndicator("Entitat",
                          res.getDrawable(R.drawable.icon_address))
                      .setContent(intent);
        tabHost.addTab(spec);
        
        intent = new Intent().setClass(this, EventsMapActivity.class);
        intent.putExtra("id_entitat", getIntent().getExtras().getString("id_entitat"));
        intent.putExtra("tipusMapa", new String("SINGLE"));
        intent.putExtra("lat", getIntent().getExtras().getString("lat"));
        intent.putExtra("lon", getIntent().getExtras().getString("lon"));
        spec = tabHost.newTabSpec("entitymapdetail").setIndicator("Mapa",
                          res.getDrawable(R.drawable.mapicon))
                      .setContent(intent);
        tabHost.addTab(spec);

      

        tabHost.setCurrentTab(0);
    }
}